// 业委会列表
<template>
  <div class="routerWapper">
    <div v-if="$route.name == 'indCous'" class="layoutMargin layoutPadding">
      <a-form :form="form" class="protalForm" >
        <a-row class="formItemLine" type="flex" align='top' :gutter="18">
          <a-col span="6">
            <a-form-item label="业主大会编码" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-input placeholder="请输入查询内容" v-decorator="['hocCode_l']" />
            </a-form-item>
          </a-col>
          <a-col span="6" >
            <a-form-item label="业委会名称" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-input placeholder="请输入查询内容" v-decorator="['hocName_l']" />
            </a-form-item>
          </a-col>
          <a-col span="6" >
            <a-form-item label="所属街道" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-select allowClear placeholder="请选择查询内容" v-decorator="['streetId']" >
                <a-select-option v-for="(item) in street" :key="item.streetId" :value="item.streetId">{{ item.strName }}</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col span="6">
            <a-form-item label="业委会到期时间" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-date-picker v-decorator="['overdueDate']" />
            </a-form-item>
          </a-col>

          <a-col span="6" >
            <a-form-item label="运作情况" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-select allowClear placeholder="请选择查询内容" v-decorator="['runSts']" >
                <a-select-option v-for="(item) in runStsList" :key="item.key" :value="item.key">{{ item.name }}</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>

          <a-col span="6" >
            <a-form-item label="换届情况" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-select allowClear placeholder="请选择查询内容" v-decorator="['changeSts']" >
                <a-select-option v-for="(item) in changeList" :key="item.key" :value="item.key">{{ item.name }}</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>

          <a-col span="6" >
            <a-form-item label="是否为党员" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
              <a-select allowClear placeholder="请选择查询内容" v-decorator="['isDY']" >
                <a-select-option v-for="(item) in dyList" :key="item.key" :value="item.key">{{ item.name }}</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <!-- 动态搜索条件 -->
          <template v-if="customKeyEnable">
            <a-col span="8"  v-for="i in searchList" :key="i.id" >
              <a-form-item :label="i.keyName" class="formItem" :label-col="{span:10}" :wrapper-col="{span:14}">
                <a-select @change="handleChangeZdy(i.keyCode,$event)" v-if="i.compntType == 'select' || i.compntType == 'radio'" showSearch allowClear placeholder="请选择查询内容" v-decorator="[i.keyCode]">
                  <a-select-option v-for="(item) in JSON.parse(i.sltJson)" :key="item" :value="item">{{ item }}</a-select-option>
                </a-select>
                <a-select @change="handleChangeZdy(i.keyCode,$event)" mode="multiple" v-else-if="i.compntType =='checkbox'"  placeholder="请选择查询内容(多选)" v-decorator="[i.keyCode]">
                  <a-select-option v-for="(item) in JSON.parse(i.sltJson)" :key="item" :value="item">{{ item }}</a-select-option>
                </a-select>
                <a-date-picker @change="handleChangeZdy(i.keyCode,$event)" v-else-if="i.compntType =='date'"  v-decorator="[i.keyCode]"  />
                <a-input v-else-if="i.compntType =='num'" type="tel" placeholder="请输入查询内容" v-decorator="[i.keyCode]" />
                <a-input v-else placeholder="请输入查询内容" v-decorator="[i.keyCode]" />
              </a-form-item>
            </a-col>
          </template>
          <!-- 功能按钮区 -->
          <a-col span="24" class="algin-right">
            <a-button  @click="exportList">导出数据</a-button>
            <a-button @click="reset">重置</a-button>
            <a-button type="primary" @click="search">搜索</a-button>
          </a-col>
        </a-row>
      </a-form>
      <!-- <p class="gayLine noline" /> -->
      <div class="portalTableOperates">
        <tableAndMut ref="childTab" :tableData="tableData" :pagination="pagination" :tbl="tbl" />
      </div>
    </div>
    <RouterWapper v-else></RouterWapper>
  </div>
</template>

<script>
export default {
  name: 'indCous',
  data() {
    return {
      customKeyEnable: false, // cookie里存的是否开启自定义字段
      tbl: 'tbl_industry_council', // 当前表名,
      searchList: [], // 动态渲染的搜索列表
      keyCodeList: [], // 动态搜索的keycode列表
      searchParams: {}, //搜索的列表
      searchForm: {},
      columns: [ //未开启自定义字段展示的列
        {
          title: '业委会名称',
          dataIndex: 'hocName',
          key: 'hocName'
        },
        {
          title: '选举时间',
          dataIndex: 'electionDate',
          key: 'electionDate'
        }, {
          title: '业委会地址',
          dataIndex: 'hocAddr',
          key: 'hocAddr'
        },
        {
          title: '业主大会编码',
          dataIndex: 'orgCode',
          key: 'orgCode'
        },
        {
          title: '操作',
          dataIndex: 'action',
          width: 160,
          scopedSlots: {
            customRender: 'action'
          }
        }
      ],
      runStsList: [
        {
          name: '正常',
          key: '1'
        },
        {
          name: '不正常',
          key: '2'
        },
        {
          name: '瘫痪',
          key: '3'
        }
      ],
      changeList: [
        {
          name: '按时换届',
          key: '1'
        },
        {
          name: '任期期满正在换届',
          key: '2'
        },
        {
          name: '任期期满但未换届',
          key: '3'
        }
      ],
      dyList: [
        {
          name: '主任与副主任是党员',
          key: '1'
        },
        {
          name: '主任是党员',
          key: '2'
        },
        {
          name: '副主任是党员',
          key: '3'
        },
      ],
      pagination: { // 分页信息
        pageNo: 1,
        pageSize: 20,
        total: 0,
        current: 1,
        showTotal: total => `总条数: ${total}`,
        defaultCurrent: 1,
        defaultPageSize: 20,
        showQuickJumper: true,
        onChange: this.pageChange,
        showSizeChanger: true,
        onShowSizeChange: this.showSizeChange,
        pageSizeOptions: ['10', '20', '50', '100'],
      },
      tableData: [],
      street: [], // 街道数据
    }
  },
  beforeCreate() { // 页面进来创建form
    this.form = this.$form.createForm(this)
  },
  created () { // 进页面获取数据
    this.customKeyEnable=this.$cookie.get('customKeyEnable')
    if(this.customKeyEnable && this.customKeyEnable == 'true'){
      // this.getKeys()
      // this.getAllKeys()
    }else {
      this.getList()
    }
  },
  mounted(){
    if (this.$route.name == 'indCous' ) {
      this.$nextTick(function () {
        this.form.setFieldsValue({'overdueDate': this.$route.query.date})
        this.getSearchParams()
        this.getStreet()
      })
    }
  },
  methods: {
    getStreet(){ //获取街道下拉
      this.$ajax.get({
        url: this.$api.GET_STREET_LIST,
        params: {
          pageSize: 10000
        }
      }).then(res => {
        this.street = this.$com.confirm(res, 'data.content', [])
      })
    },
    handleChangeZdy(i, e){ // 自定义字段 - 搜索条件的 change
      if (Object.prototype.toString.call(e)== '[object Array]') {
        e2 = e.join(',')
      } else if (Object.prototype.toString.call(e)== '[object Object]') {
        e2 = this.$moment(e).format('YYYY-MM-DD')
      }
      this.form.setFieldsValue({ // 传入的i 是i.keyCode 将form表单设置成最新的值
        i: e2
      })
      setTimeout(() => { // 延时器,去掉会拿不到最新的value
        this.getList()
      }, 0)
    },
    getList(){ // 获取数据
      //处理动态的搜索条件,耦合到搜索列表
      const obj = {}
      this.keyCodeList.forEach(item => {
        let value = !this.form.getFieldValue(item)? '':this.form.getFieldValue(item)
        if (Object.prototype.toString.call(value)== '[object Array]') { //如果是数组
          value = value.join(',')
        }else if(Object.prototype.toString.call(value) === '[object Object]'){
          value = this.$moment(value).format('YYYY-MM-DD')
        }
        this.$set(obj, item, value)
      })
      const searchParams = Object.assign({}, {
        'hocCode_l': this.form.getFieldValue('hocCode_l') || '',
        'hocName_l': this.form.getFieldValue('hocName_l') || '',
        'streetId': this.form.getFieldValue('streetId')?this.form.getFieldValue('streetId'):'',
        'conEndDate_lte': !!this.form.getFieldValue('overdueDate')? (this.$moment(this.form.getFieldValue('overdueDate')).format('L')).split('/').join('') : '',
        'onwersTypeoper': !!this.form.getFieldValue('runSts')? this.form.getFieldValue('runSts'): '',
        'onwersTransition': !!this.form.getFieldValue('changeSts')? this.form.getFieldValue('changeSts'): '',
        'partyMemberByDuty': !!this.form.getFieldValue('isDY')? this.form.getFieldValue('isDY'): '',
        'sectType_in': '1',
      }, obj)
      this.searchParams = searchParams
      this.$ajax.get({
        url: this.$api.GET_INDCOUS_LIST,
        params: Object.assign({}, searchParams, {
          pageSize: this.pagination.pageSize,
          pageNo: this.pagination.pageNo
        })
      }).then(res => {
        if (res.code === '200') {
          // 正常请求数据得到的结果
          this.pagination.total= this.$com.confirm(res, 'data.totalRows', 0)
          this.tableData = this.$com.confirm(res, 'data.content', [])
        }
        //
        // 存储当前页面列表的搜索信息
        //
        this.$com.storeSearchParams(
          this.$route.name,
          this.pagination,
          searchParams
        )
      })
    },
    /**
     * 从vuex中或已存储的搜索条件，判断此条件是否为当前路由的 。如果是则使用
     */
    getSearchParams(){
      const searchParams = !this.$store.state.listSearchParams?null:this.$store.state.listSearchParams[this.$route.name]
      if(!!searchParams && !!searchParams.routeName && (this.$route.name == searchParams.routeName)){
        if(!!searchParams.params){
          Object.keys(searchParams.params).forEach(elem => {
            switch (elem) {
            case 'hocCode_l':
              this.form.setFieldsValue({ 'hocCode_l': searchParams.params[elem] })
              break
            case 'hocName_l':
              this.form.setFieldsValue({ 'hocName_l': searchParams.params[elem] })
              break
            case 'streetId':
              this.form.setFieldsValue({ 'streetId': searchParams.params[elem] })
              break
            default:
              break
            }
          })
        }
        if(!!searchParams.pagination){
          if(!!searchParams.pagination.pageNo){
            this.pagination.pageNo = searchParams.pagination.pageNo
            this.pagination.current = searchParams.pagination.current
            this.pagination.pageSize = searchParams.pagination.pageSize
          }
        }
      }
      this.getList()
    },
    pageChange(page){ //分页切换
      this.pagination.pageNo = page
      this.pagination.current = page
      this.getList()
    },
    showSizeChange(current, size) { //每页条数切换
      this.pagination.pageNo = 1
      this.pagination.current = 1
      this.pagination.pageSize = size
      this.getList()
    },
    reset(){ // 重置表单
      this.form.resetFields()
      this.pagination.pageNo = 1
      this.pagination.current = 1
      this.pagination.pageSize = 20
      this.getList()
    },
    search() { // 搜索按钮
      this.pagination.current = 1
      this.pagination.pageNo = 1
      //需要发送ajax
      this.getList()
    },
    toView(params){ // 查看详情
      this.$router.push({path: `/houseData/indCou/${params.id}`, query: {id: params.id}})
    },
    toMem(params){ // 成员页面
      this.$router.push({path: '/houseData/members', query: {id: params.id}})
    },
    exportList(){ //导出功能
      const formValue = this.form.getFieldsValue() 
      let newUrl = this.tbl + '?'
      let newObj = {}

      for(const k in formValue){ 
        if (formValue[k]!= undefined ) { // 判断是否值为 undefined
          if(Object.prototype.toString.call(formValue[k])== '[object Array]'){
            // 数组的话就拼接字符串
            newUrl += k +'=' + formValue[k].join(',') + '&'
          }else if (Object.prototype.toString.call(formValue[k]) === '[object Object]') {
            //时间格式对象就转换成字符串
            newUrl += k +'=' +this.$moment(formValue[k]).format('YYYY-MM-DD') +'&'
          }else {
            newUrl += k +'=' +formValue[k] +'&' //没有特殊情况  直接拼接到 newUrl
          }
        } 
      }
      let token = this.$cookie.get('token') // 获取token 并拼接到 newUrl
      newUrl += 'sectType=1&token=' + token 
      window.open (this.$api.BASE_URL+'/service-basicdatasync-ddd/export/'+ newUrl)
    },
  },

}
</script>

<style scoped>

</style>

